//Classe ElementFormuleExpression : si un lment de formule est une expression (et pas un nombre ni un identifiant de cellule), il sera une instance de cette classe
import java.util.*;
public class ElementFormuleExpression implements ElementFormule
{
 
    private char op; //op contiendra soit '+' soit '*' soit '-' soit '/'
    private ElementFormule[] arguments;

    public ElementFormuleExpression(char operation, ElementFormule[] args) throws FormuleException
    {
	op = operation;
	arguments = args;
	if (arguments.length == 0) // On n'a pas d'arguments
	    {
		throw new FormuleException("Expression sans arguments");
	    }
	if (((op == '-') || (op == '/')) && (arguments.length != 2)) //Selon la syntaxe donne dans l'nonc, les soustractions et les divisions doivent avoir deux arguments.
	    {
		throw new FormuleException("Mauvais nombre d'arguments dans une soustration ou une division");
	    }
	if (op != '+' && op != '-' && op != '/' && op != '*')
	    {
		throw new FormuleException("L'oprateur de l'expression est invalide");
	    }
    }
    
    //Mthode evalue(valeurs) : renvoit l'valuation de l'expression
    public double evalue(CaseRepresentationInterne[][] representationInterne, HashSet parcours) throws FormuleException
    //Quand on demandera l'valuation d'un argument de l'expression on passera en paramtre une copie de 'parcours' au lieu de 'parcours' lui-mme car une mme case 
    //peut tre value  plusieurs endroits dans l'arbre sans faire de cycle : il faut dtecter qu'une case s'appelle elle-mme et pas qu'une case est appele plusieurs fois
    {
	double valeur=0;     //Variable temporaire qui  la fin de la mthode contiendra l'valuation de l'expression

	switch(op)
	    {
	    case '+': //Calcul d'une addition
		valeur = 0;
		for (int k=0;k<arguments.length;k++)
		    valeur = valeur + (arguments[k].evalue(representationInterne, new HashSet(parcours)));
		break;

	    case '-': //Calcul d'une soustraction
		valeur = arguments[0].evalue(representationInterne, new HashSet(parcours))-arguments[1].evalue(representationInterne, new HashSet(parcours));
		break;

	    case '*': //Calcul d'une multiplication
		valeur = 1;
		for (int k=0;k<arguments.length;k++)
		    valeur = valeur * arguments[k].evalue(representationInterne, new HashSet(parcours));
		break;
		
	    case '/': //Calcul d'une division
		double a1=arguments[1].evalue(representationInterne, new HashSet(parcours));
		if (a1!=0)
		    valeur = arguments[0].evalue(representationInterne, new HashSet(parcours))/a1;
		else
		    throw new FormuleException("Division par zro");
		break;
	    }
	return valeur;
    }
}
