//Etape3

//classe ElementFormuleIdentifiantCellule : si un lment de formule est une rfrence vers une case du tableau
//de la reprsentation interne, il sera une instance de cette classe
import java.util.*;
public class ElementFormuleIdentifiantCellule implements ElementFormule {
    
    private int ligne;
    private int colonne;
    
    //CONSTRUCTEUR : cre un nouvel ElementFormuleIditentifiantCellule : on ajoute une rfrence vers la cellule (ligne,colonne) du tableau de la reprsentation interne
    //le constructeur aura besoin d'une rfrence vers la cellule source de l'appel du constructeur et d'une rfrence vers le tableau de la reprsentation interne car
    //il faut signaler  la cellule cible qu'elle est rfrence par la cellule source
    public ElementFormuleIdentifiantCellule(String expression, CaseRepresentationInterne source, CaseRepresentationInterne[][] representationInterne) throws FormuleException {
	char c;

	if (expression.length()!=2) {    //L'expression doit tre EXACTEMENT de longueur 2 (par ex A0,J9, ...)
	    throw new FormuleException("L'identifiant de cellule pass en paramtre n'a pas le bon nombre de caractres");
	}

	//Premire tape : on traite le numro de la colonne pass en paramtre
	c=expression.charAt(0);  //Le premier caractre de expression DOIT tre la lettre de la colonne en MAJUSCULES
	if ((c < 'A') || (c > 'J')) {  //Si c n'est pas compris entre 'A' et 'J' ce n'est pas une colonne valide
	    throw new FormuleException("Le premier caractre de l'indentifiant de cellule n'est pas une lettre valide\n utilisez des MAJUSCULES !");
	}
	//On convertit la lettre de la colonne en un int 
	colonne=((int)(c)-(int)('A'));  //On soustrait le code ASCII du 'A' pour que 'A' <=> 0
	
	//Deuxime tape : on traite le numro de la ligne pass en paramtre
	c=expression.charAt(1); //Le deuxime caractre de expression DOIT tre le chiffre de la ligne
	if ((c < '0') || (c > '9')) { //Si c n'est pas compris entre '0' et '9' ce n'est pas un chiffre
	    throw new FormuleException("Le second caractre de l'identifiant de cellule n'est pas un chiffre");
	}
	//On convertit le chiffre de la ligne en un int
	ligne=((int)(c)-(int)('0'));  //On soustrait le code ASCII du '0' pour que '0' <=> 0

	//Ici on a les coordonnes correctes de la cellule que la cellule source veut rfrencer. On indique  la cellule cible qu'elle est rfrence par la cellule source
	representationInterne[ligne][colonne].ajouteCelluleLiee(source);
    }    
    
    //Mthode evalue : renvoit la valeur de la case (ligne, colonne) de la reprsentation interne
    public double evalue(CaseRepresentationInterne[][] representationInterne, HashSet parcours) throws FormuleException{
	//System.out.println("Il faudra valuer la case ("+ligne+","+colonne+") de la reprsentation interne");
	return representationInterne[ligne][colonne].evalue(representationInterne, parcours);
    }
}


											       
