//Etape 4
/* Changements par rapport  l'tape 3:
L'utilisation de plusieurs feuilles de calcul devant tre permise, une grande partie des mthodes de la classe Interface de l'tape 3 se retrouvent dans une nouvelle classe: "PanneauGrilleEditeur".
 - on a ajout une classe interne qui implmente ChangeListener, pour afin le titre de la fenetre lorsqu'on change d'onglet.
 - La classe interne FiltreSTP a t dplace dans la classe PanneauGrilleEditeur
 - l'Interface contient une instance de JTabbedPane (composant Swing qui groupe une liste de panneaux (instances de PanneauGrilleEditeur) reprs par des onglets).
 - Les grilles et les zones d'dition seront dans les PanneauGrilleEditeur, de mme que la variable fichierEnEdition.
   Pour avoir une rfrence vers le PanneauGrilleEditeur courant, on appelera la mthode getSelectedComponent du JTabbedPane.
 - la nouvelle mthode prive titreFenetre appelle la mthode setTitle de la classe JFrame.  Pour changer le titre de la fentre on devra appeler titreFenetre(nom_du_fichier) au lieu de 
   setTitle(TITRE_FENETRE + " + nom_du_fichier").
 - dans le constructeur, on instancie un JTabbedPane qui sera repr par la variable tabPane; dans celui-ci on ajoute une instance de PanneauGrilleEditeur (comprenant une grille et zone d'dition vides).
   On change le titre de la fenetre (en appelant la mthode donneTitreRaccourci de la classe PanneauGrilleEditeur) et on ajoute un ChangeListener au JTabbedPane.
   Les oprations d'instanciation de ZoneEdition et de Grille se retrouvent dans le constructeur de la classe PanneauGrilleEditeur.
 - le menu "Nouveau" du menu "fichier" permet d'ajouter une nouvel onglet dans le JTabbedPane.
 - le menu "Fermer le fichier courant" du menu "fichier" supprime le panneau contenant la grille et la zone d'dition correspondant au fichier courant; avant cela il appelle la mthode operationsFermeture 
   de la classe PanneauGrilleEditeur qui demandera ventuellement si l'utilisateur veut sauvegarder le fichier avant de le fermer.
 - quand on cliquera sur le menu "Chargement", on fermera d'abord le fichier courant.  Ensuite, si l'utilisateur n'a pas annul, on appelera la mthode chargement() du PanneauGrilleEditeur et on forcera la cration 
   d'un ChangeEvent afin de changer le titre de la fentre.  Enfin, on donne le nom du fichier que l'on a charg au titre l'onglet.
 - quand on cliquera sur le menu "Enregistrer", on appelle la mthode enregistrer() du PanneauGrilleEditeur et si l'utilisateur n'a pas annul l'enregistrement, on force la cration d'un ChangeEvent afin de changer
   le titre de la fentre et on change galement le nom de l'onglet (idem pour "Enregistrer sous ...").
 - pour copier, couper et coller, on appelle les mthodes correspondantes dans la classe PanneauGrilleEditeur.
 - le code des  mthodes chargement, enregistrer et enregistrerSous de l'tape 3 se retrouve dans la classe PanneauGrilleEditeur.
 - On a plus besoin d'implmenter l'interface KeyListener car cela grait le pressions des touches dans la zone d'dition.  On implmente  prsent cette interface (les mthodes keyTyped, keyReleased et keyPressed)
   dans la classe PanneauGrilleEditeur.
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import java.util.*;    
import java.io.*;

public class Interface extends JFrame implements ActionListener
{
    //Dfinition des constantes prives
    private static final int HAUTEUR_FENETRE = 350;
    private static final int LARGEUR_FENETRE = 600;

    private static final String TITRE_FENETRE = "(-: Super Tableur Pro :-)";
 
    //variables globales

    private JMenuItem coller; //On n'activera l'option coller que si le presse papiers est non vide -> il faudra garder une rfrence vers cet lment du menu
    private JTabbedPane tabPane;  //Le composant qui permettra de slectionner plusieurs grilles
    
    //Constructeur
    public Interface() {
        setSize(LARGEUR_FENETRE, HAUTEUR_FENETRE);    //On commence par donner une taille dcente  la fentre

	setJMenuBar(getMenu());                                   //On cre le menu

	//On cre le JTabbedPane qui contiendra les divers PanneauGrilleEditeur
	tabPane = new JTabbedPane();        
	getContentPane().add(tabPane);

	tabPane.add(new PanneauGrilleEditeur());
	tabPane.setTitleAt(0,((PanneauGrilleEditeur)tabPane.getSelectedComponent()).donneTitreRaccourci()); //On donne un titre  l'onglet

	//On met  la fentre principale le nom du programme + le nom de la grille courante (ici ce sera toujours sansNom1)
	titreFenetre(((PanneauGrilleEditeur) tabPane.getSelectedComponent()).donneTitre());

	//On dit  tabPane que chaque fois qu'un vnement ChangeEvent se produit (i.e. quand l'utilisateur change la feuille de calcul courante), il faudra
	//appeler l'instance selectedTabChanged de la classe changeListener (voir fin du code)
	tabPane.addChangeListener(selectedTabChanged);   

	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);            //Quand l'utilisateur fermera la fentre, ne rien faire, c'est le WindowListener qui gre la fermeture de la fentre
	this.addWindowListener(closeWindow);                      //on ajoute un gestionnaire d'vnements qui sera appel  la fermeture de la fentre
    }

    private void titreFenetre(String nom)
    {
	super.setTitle(TITRE_FENETRE + " - " + nom);
    }

    //Le menu
    private JMenuBar getMenu() {
	JMenuBar barreDeMenu = new JMenuBar();
	
	//Menu fichier
	JMenu fichier = new JMenu("Fichier");

	JMenuItem nouveau = new JMenuItem("Nouveau");
	nouveau.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK)); //Raccourci clavier pour crer une nouvelle feuille de calcul: "CTRL + N"
	fichier.add(nouveau);
	nouveau.addActionListener(this);

	JMenuItem chargement = new JMenuItem("Chargement");
	chargement.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK)); //Raccourci clavier pour un chargement: "CTRL + O"
	fichier.add(chargement);
	chargement.addActionListener(this);      //Quand on cliquera sur le menu "Chargement", la mthode actionPerformed de cette classe sera invoque

	JMenuItem enregistrer = new JMenuItem("Enregistrer");
	enregistrer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK)); //Raccourci clavier pour une sauvegarde: "CTRL + S"
	fichier.add(enregistrer);
	enregistrer.addActionListener(this);

	JMenuItem enregistrerSous = new JMenuItem("Enregistrer sous ...");
	fichier.add(enregistrerSous);
	enregistrerSous.addActionListener(this);

	fichier.addSeparator();

	JMenuItem fermerFichierCourant = new JMenuItem("Fermer le fichier courant");
	fichier.add(fermerFichierCourant);
	fermerFichierCourant.addActionListener(this);
      
	JMenuItem quitter = new JMenuItem("Quitter");
	fichier.add(quitter);
	barreDeMenu.add(fichier);
	quitter.addActionListener(this);

	//Menu dition
	JMenu edition = new JMenu("Edition");

	JMenuItem copier = new JMenuItem("Copier");
	copier.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK)); //Raccourci clavier pour copier: "CTRL + C"
	edition.add(copier);
	copier.addActionListener(this); 

	JMenuItem couper = new JMenuItem("Couper");
	couper.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK)); //Raccourci clavier pour couper: "CTRL + X"
	edition.add(couper);
	couper.addActionListener(this); 

	coller = new JMenuItem("Coller");
	coller.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK)); //Raccourci clavier pour coller: "CTRL + V"
	edition.add(coller);
	coller.addActionListener(this); 
	coller.setEnabled(false);   //On activera l'option coller quand le presse-papiers contiendra quelque-chose
	barreDeMenu.add(edition);

	return barreDeMenu;
    }
    
    //mthode actionPerformed : ragit aux vnements du menu
    public void actionPerformed(ActionEvent evt)
    {
	//Gestion des vnements lis au menu
	if (evt.getSource() instanceof JMenuItem)
	    {
		String ChoixOption = evt.getActionCommand();
		if (ChoixOption.equals("Quitter"))
		    {
			//On appelle aussi l'instance closeWindow pour grer la fermeture du programme
			//(voir la fin du code source pour de plus amples informations sur closeWindow) 
			closeWindow.windowClosing(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
		    }
		else if (ChoixOption.equals("Nouveau"))
		    {
			tabPane.add(new PanneauGrilleEditeur());
			tabPane.setSelectedIndex(tabPane.getTabCount()-1);
			tabPane.setTitleAt(tabPane.getTabCount()-1,((PanneauGrilleEditeur) tabPane.getSelectedComponent()).donneTitreRaccourci()); //On renomme le titre de l'onglet
		    }
		else if (ChoixOption.equals("Chargement"))
		    {
			if (((PanneauGrilleEditeur) tabPane.getSelectedComponent()).operationsFermeture()) //Si l'utilisateur n'a pas ANNULE l'ventuel enregistrement de la feuille en cours d'dition
			    {
				((PanneauGrilleEditeur) tabPane.getSelectedComponent()).chargement();
				selectedTabChanged.stateChanged(new ChangeEvent(this)); //On force la cration d'un ChangeEvent afin de changer le titre de la fentre.
				tabPane.setTitleAt(tabPane.getSelectedIndex(),((PanneauGrilleEditeur) tabPane.getSelectedComponent()).donneTitreRaccourci()); //On renomme le titre de l'onglet
			    }
		    }
  		else if (ChoixOption.equals("Enregistrer"))
		    {
		    	if (((PanneauGrilleEditeur) tabPane.getSelectedComponent()).enregistrer())
			    {
				selectedTabChanged.stateChanged(new ChangeEvent(this)); //On force la cration d'un ChangeEvent afin de changer le titre de la fentre.
				tabPane.setTitleAt(tabPane.getSelectedIndex(),((PanneauGrilleEditeur) tabPane.getSelectedComponent()).donneTitreRaccourci()); //On renomme le titre de l'onglet
			    }
		    }
		else if (ChoixOption.equals("Enregistrer sous ..."))
		    {
			if (((PanneauGrilleEditeur) tabPane.getSelectedComponent()).enregistrerSous())
			    {
				selectedTabChanged.stateChanged(new ChangeEvent(this)); //On force la cration d'un ChangeEvent afin de changer le titre de la fentre.
				tabPane.setTitleAt(tabPane.getSelectedIndex(),((PanneauGrilleEditeur) tabPane.getSelectedComponent()).donneTitreRaccourci()); //On renomme le titre de l'onglet
			    }
		    }
		else if (ChoixOption.equals("Fermer le fichier courant"))
		    {
			if  (((PanneauGrilleEditeur) tabPane.getSelectedComponent()).operationsFermeture())
			    tabPane.remove(tabPane.getSelectedIndex());
			if (tabPane.getTabCount() == 0)
			    closeWindow.windowClosing(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
		    }
		else if (ChoixOption.equals("Copier"))
		    {
		
			if (((PanneauGrilleEditeur) tabPane.getSelectedComponent()).copier())
			    coller.setEnabled(true); //On active l'option coller si des cellules ont t effectivement copies
		    }
		else if (ChoixOption.equals("Couper"))
		    {
		
			if(((PanneauGrilleEditeur) tabPane.getSelectedComponent()).couper())	
			    coller.setEnabled(true); //On active l'option couper si des cellules ont t effectivement coupes
		    }
		else if (ChoixOption.equals("Coller"))
		    {
			((PanneauGrilleEditeur) tabPane.getSelectedComponent()).coller();
		    }
	    }
    }



    //Cette instance d'une classe tendant WindowAdapter est appele chaque fois qu'on veut fermer la fentre du tableur
    WindowListener closeWindow=new WindowAdapter ()
	{
	    //mthode qui contrle la fermeture de la fentre
	    public void windowClosing(WindowEvent we)
	    {
		for (int i=0;i<tabPane.getTabCount();i++)
		    {
			tabPane.setSelectedIndex(i);
			if(!((PanneauGrilleEditeur) tabPane.getSelectedComponent()).operationsFermeture())
			    return; //On ne quitte pas le tableur si l'utilisateur a ANNULE un des enregistrements.
		    }
		//Ici, l'utilisateur a fait son choix concernant l'enregistrement de toutes les grilles et n'a pas annul l'enregistrement d'une d'entre-elles, on peut quitter
		System.exit(0);
	    }
	};

    //Cette instance de ChangeListener est appele chaque fois qu'un change d'onglet dans le JTabbedPane
    ChangeListener selectedTabChanged = new ChangeListener()
	{
	    public void stateChanged(ChangeEvent e)
	    {
		//On demande au PanneauGrilleEditeur slectionn de donner son titre, mais on doit s'assurer qu'il y a encore un PanneauGrilleEditeur
		PanneauGrilleEditeur p = (PanneauGrilleEditeur)tabPane.getSelectedComponent();
		if (p != null) {
		    titreFenetre(p.donneTitre());
		}
	    }
	};
}
