//ETAPE3
/*Changements par rapport  l'tape 2:
 - puisqu'on a supprim la classe Constantes, on a ajout les constantes SEPARATEUR, NB_COLONNES et NB_LIGNES ici
 - nouvelle variable globale modifiee : indique si cette instance de la reprsentation interne a t 
   modifie depuis la dernire sauvegarde
 - le deuxime constructeur qui crait une CaseRepresentationInterne non vide a t supprim.
 - la classe Loader a t supprime et le code des mthodes load et save a t transfr  l'intrieur de cette classe;
   On ne cre plus chaque cellule dans la mthode load, car quand on appelle la mthode load, on est certain que la 
   reprsentation interne est cre et que toutes ses cellules sont non null. Il suffit alors d'appeler la mthode
   setValueAt pour donner la valeur correcte aux cellules de la reprsentation interne.
   La mthode save utilise la mthode getEditorTextAt pour savoir quoi crire dans le fichier. 
   Donc les mthodes load et save n'interragissent plus directement avec le tableau de la reprsentation interne
 - la mthode setValueAt a t mofifie : elle renvoie maintenant un tableau de Coordonnees qui contiendra les coordonnes 
   des cellules  redessiner dans la grille aprs avoir chang la valeur d'une case. La mthode setValueAt n'effectuera aucune 
   action si le texte qu'on lui demande de placer dans la case (i,j) de la reprsentation interne est le mme que celui dj prsent.
 - nouvelle mthode, estModifiee() : renvoit la valeur de modifiee (pour des raisons de visibilit)
 - la mthode deleteEditingCell() n'existe plus
*/
import java.io.*;               //Dfinit les exceptions du type IOException

public class RepresentationInterne {

    //Dfinition du sparateur des cellules dans le fichier de texte
    private static final char SEPARATEUR = (char)(26);     //private, car on s'en sert que dans RepresentationInterne

    //Dfinition dez nombre de lignes et de colonnes dans le tableau
    public static final int NB_LIGNES = 10;                //public, car on s'en sert dans plein de classes
    public static final int NB_COLONNES = 10;

    private CaseRepresentationInterne[][] valeurs;  //Les donnes que la classe va grer en interne
    private boolean modifiee;                       //Vaut true quand cette representation interne a t modifie

    //CONSTRUCTEUR1 : Cre une reprsentation interne vide
    public RepresentationInterne() {
	super();
	valeurs = new CaseRepresentationInterne[NB_LIGNES][NB_COLONNES];
	//On va initialiser chaque cellule de la reprsentation interne (ce sera une cellule vide)
	for (int i = 0; i < NB_LIGNES; i++) {
	    for (int j = 0; j < NB_COLONNES; j++) {
		valeurs[i][j] = new CaseRepresentationInterne(i,j);   //On communique  la case la position qu'elle aura au sein du tableau
	    }
	}
	modifiee = false;
    }

    //Mthode load : charge le fichier fileName et le place dans la reprsentation interne. Lors du chargement, on s'assure que le format de fichier est correct.
    //Si un problme de format de fichier est dcouvert, on lance une FormatException
    public void load(String fileName) throws IOException, FormatException {

	//on initialise la lecture du fichier
	BufferedReader incoming = new BufferedReader(new FileReader(new File(fileName)));
	try{
	    String ligne,element;    //variables temporaires
	
	    //on parcourt le fichier
	    for (int i=0;((ligne=incoming.readLine())!=null) && (i<NB_LIGNES);i++){
		int compteur=0;       	// chaque nouvelle ligne, on commence  compter le nombre de sparateurs
		int k=0;		//variable qui sert comme indice de dbut des lments
		int parcoursDeLaLigne;	//repre l'indice du caractre o on se trouve dans la ligne
		    
		//on parcourt tous les caractres de la ligne
		//dans cette boucle, on cre les elements du tableau, sauf le dernier, qui est cr aprs la boucle
		for (parcoursDeLaLigne=0;parcoursDeLaLigne<ligne.length();parcoursDeLaLigne++){		
		    //si on dtecte un signe de sparation, on augmente le compteur
		    if (ligne.charAt(parcoursDeLaLigne)==SEPARATEUR){
			//quand on trouve un sparateur, il faut que a ne soit pas le dernier ou le premier caractre de la ligne
			//et que le prochain caractre ne soit pas un sparateur.
			if ((parcoursDeLaLigne==ligne.length()-1) ||  //si on est au dernier caractre de la ligne et qu'on a un sparateur, a ne va pas
			    (parcoursDeLaLigne==0) || //a ne va pas non plus si on trouve un sparateur au premier caractre de la ligne
			    (parcoursDeLaLigne<ligne.length()-1 && ligne.charAt(parcoursDeLaLigne+1)==SEPARATEUR)) {  //format incorrect si deux sparateurs se suivent directement
			    throw new FormatException("Mauvais format ! Soit il y a un sparateur en dbut ou en fin de ligne \nsoit deux sparateurs de suite !");
			}
			//dans element, on met l'lment suivant : il commence  l'indice k+1 (parce qu'on a ajout un espace devant 
			//chaque cellule dans le format de fichier) et s'arrte  l'indice parcoursDeLaLigne-1
			if (ligne.charAt(k)==' ') {     //On s'assure qu'une cellule commence bien par un espace
			    element=ligne.substring(k+1,parcoursDeLaLigne);
			}
			else {
			    throw new FormatException("Mauvais format ! Une cellule ne commence pas par un espace !");	
			}
			//en k, en met l'indice du sparateur + 1 : l'indice du dbut de l'lment suivant
			k=parcoursDeLaLigne+1;
			
			//on ajoute l'lment dans la reprsentation interne
			try{
			    setValueAt(element,i,compteur);
			}
			catch(FormuleException e) { }  //On dcide de ne rien faire si une dfinition circulaire est dtecte lors du chargement
			
			compteur++;
		    }
		}
		
		//quand on dtecte trop ou trop peu de sparateurs, on lance une exception
		if (compteur!=NB_COLONNES-1){
		    throw new FormatException("Mauvais format ! Il n'y a pas le bon nombre de colonnes dans une ligne !");
		}
		
		//si le dernier lment ne commence pas par un espace, on lance une exception
		if (ligne.charAt(k)!=' '){
		    throw new FormatException("Mauvais format ! Une cellule ne commence pas par un espace !");
		}
		
		//si on arrive ici, alors la ligne a le bon format et on cre le dernier lment
		try{
		    setValueAt(ligne.substring(k+1,ligne.length()), i, NB_COLONNES-1);
		}
		catch (FormuleException e) { } //On dcide de ne rien faire si une dfinition circulaire est dtecte lors du chargement
	    }
		
	    //s'il y trop de lignes, on lance une Exception
	    if (ligne!=null){
		throw new FormatException("Mauvais format ! Trop de lignes dans le fichier !");
	    }
	    modifiee = false;   //Quand on a charg une nouvelle grille, la representation interne est remise a un tat non modifi
	}
	
	finally{  //quoi qu'il arrive, il faut fermer le fichier
	    incoming.close();
	}
    } 

    //Mthode save : enregistre le contenu de la reprsentation interne dans le fichier fileName
    public void save(String fileName) throws IOException {
	//on cre un nouveau fichier et on initialise l'criture
	PrintWriter output = new PrintWriter (new FileWriter(new File(fileName)));
	
	try{
	    //on parcourt le tableau
	    for (int i=0;i<NB_LIGNES;i++){
		for (int j=0;j<NB_COLONNES;j++){			
		    output.print(" "+getEditorTextAt(i,j));    //Chaque cellule sera prcde d'un espace par convention		      
		    //tant qu'on n'est pas au dernier lment, on ajoute un sparateur
		    if (j<NB_COLONNES-1) output.print(SEPARATEUR);
		}
		
		// la fin de chaque ligne du tableau, on passe  la ligne dans le fichier
		output.println();
	    }
	    modifiee = false;  //Quand on l'a enregistre, la representation interne est remise a un tat non modifi
	}
	finally{   //quoi qu'il arrive on ferme le fichier
	    output.close();
	}
    }
	
    //Mthode getEditorTextAt : renvoit une forme ditable (sous forme de String) de la reprsentation de la case (i,j)
    public String getEditorTextAt(int i, int j) {
	return (valeurs[i][j].getEditorText());
    }
    
    //Mthode getExternalRepresentationAt : renvoit la reprsentation "externe" (i.e. le texte  afficher dans la grille) de la case (i,j) de la reprsentation interne
    public String getExternalRepresentationAt(int i, int j) {
	return (valeurs[i][j].getExternalRepresentation(valeurs));
    }

    //Methode getTypeAt : renvoit le type de la case (i,j) de la reprsentation interne
    public int getTypeAt(int i, int j) {
	return (valeurs[i][j].getType());
    }

    //Mthode setValueAt : donne la valeur s  la case (i,j) du tableau de la reprsentation interne. Renvoit un vecteur contenant la position de toutes les cellules qu'il faudra redessiner
    //Si une dfinition circulaire rendant la recherche des cases  redessiner est rencontre, une FormuleException est lance
    public Coordonnees[] setValueAt(String s, int i, int j) throws FormuleException {
	if (!(s.equals(valeurs[i][j].getEditorText()))) {  //On n'crira la valeur dans la reprsentation interne que si elle est diffrente de celle dj prsente
	    modifiee = true;   //Si on a d changer la case, la reprsentation interne est modifie
	    //On passe une rfrence vers le tableau complet de la reprsentation pour pouvoir dterminer la liste des cellules qu'il faudra redessiner suite  la modification de la case (i,j)
	    return valeurs[i][j].setValue(s, valeurs);   //On renvoit la liste des coordonnes des cellules  redessiner
	}
	else {  //Si on n'a pas d modifier la reprsentation interne, il ne faut redessiner aucune cellule
	    return new Coordonnees[0];   //On renvoit un vecteur vide
	}
    }

    //Mthode estModifiee() : dtermine si la reprsentation interne a t modifie sans tre enregistre
    public boolean estModifiee() {
	return modifiee;
    }
}
